import network
import time
from machine import Pin
import dht
from umqtt.simple import MQTTClient

# MQTT Server Parameters
MQTT_CLIENT_ID = "CTsvBgXcHRkmMRICHxwVGxE"
MQTT_BROKER = "mqtt3.thingspeak.com"
MQTT_USER = "CTsvBgXcHRkmMRICHxwVGxE"
MQTT_PASSWORD = "Hs0CEJ+Xf1XD2XCMIjCNIqld"
MQTT_TOPIC = "channels/2232412/publish"

#WIFI parameters
WIFI_SSID  = xxxxxxxxx
WIFI_PASSWD = YYYYYYY

#GPIO16

sensor = dht.DHT11(Pin(16))
#sensor = dht.DHT22(Pin(16))

#Create a WLAN network interface object. STA_IF = station aka client, connects to upstream WiFi access points
print("Connecting to WiFi", end="")
nic = network.WLAN(network.STA_IF)
nic.active(True)
nic.connect(WIFI_SSID, WIFI_PASSWD)
while not nic.isconnected():  
    print(".", end="")  
    time.sleep(0.1)
print(" Connected!")

print("Connecting to MQTT server... ", end="")
client = MQTTClient (MQTT_CLIENT_ID, MQTT_BROKER, user = MQTT_USER, password = MQTT_PASSWORD)
client.connect()
print("Connected!")

prev_weather = ""
while True:  
    print("Measuring weather conditions... ", end="")
    sensor.measure()      
    message="field1={temp}&field2={hum}&status=MQTTPUBLISH".format(temp=sensor.temperature(),hum=sensor.humidity()) 
    print(message)  
    if message != prev_weather:    
        print("Updated!")    
        print("Reporting to MQTT topic {}: {}".format(MQTT_TOPIC, message))    
        client.publish(MQTT_TOPIC, message)
        prev_weather = message  
    else:    
        print("No change")  
    time.sleep(1)